
#import "UIColor+JTGestureBasedTableViewHelper.h"

@implementation UIColor (JTGestureBasedTableViewHelper)
// used to add brightness to a color,can be removed not used in the code now
- (UIColor *)colorWithBrightness:(CGFloat)brightnessComponent {
    
    UIColor *newColor = nil;
    if ( ! newColor) {
        CGFloat hue, saturation, brightness, alpha;
        if ([self getHue:&hue saturation:&saturation brightness:&brightness alpha:&alpha]) {
            newColor = [UIColor colorWithHue:hue
                                  saturation:saturation
                                  brightness:brightness * brightnessComponent
                                       alpha:alpha];
        }
    }
    
    if ( ! newColor) {
        CGFloat red, green, blue, alpha;
        if ([self getRed:&red green:&green blue:&blue alpha:&alpha]) {
            newColor = [UIColor colorWithRed:red*brightnessComponent
                                       green:green*brightnessComponent
                                        blue:blue*brightnessComponent
                                       alpha:alpha];
        }
    }
    
    if ( ! newColor) {
        CGFloat white, alpha;
        if ([self getWhite:&white alpha:&alpha]) {
            newColor = [UIColor colorWithWhite:white * brightnessComponent alpha:alpha];
        }
    }
    
    return newColor;
}

// used to add hue offset to a colorwhile pinching to create or pull down to create
- (UIColor *)colorWithHueOffset:(CGFloat)hueOffset {
    UIColor *newColor = nil;
    if ( ! newColor) {
        CGFloat hue, saturation, brightness, alpha;
        if ([self getHue:&hue saturation:&saturation brightness:&brightness alpha:&alpha]) {
            // We wants the hue value to be between 0 - 1 after appending the offset
            CGFloat newHue = fmodf((hue + hueOffset), 1);
            newColor = [UIColor colorWithHue:newHue
                                  saturation:saturation
                                  brightness:brightness
                                       alpha:alpha];
        }
    }
    return newColor;
}
@end